
/**
 * Write a description of class PersonalCar here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PersonalCar implements Car
{
    // instance variables - replace the example below with your own
    private int persons; //persons on board
    private int maxPersons; //maximum of  allowed persons
    private String type;
    private int fuel;

    /**
     * Constructor for objects of class PersonalCar
     * @param type car type
     * @param maxPersons maximum number of allowed persons
     * @param persons persons to be initiali loaded. When persons  &gt; maxPersons only 
     *                maxPersons will be loaded.
     */
    public PersonalCar(String type, int maxPersons, int persons) {
        fuel = 0;
        this.maxPersons = maxPersons;
        if (persons <= maxPersons) this.persons = persons;
        else this.persons = maxPersons;
        this.type = type;
       }

    
    /**
     * Returns String representation of the particular object.
     * @return String representation of the object in the form:
     *                  "&lt;type&gt; (&lt;maxPersons&gt;): &lt;persons&gt; persons \tfuel: &lt;fuel&gt;\n"
     * 
     */
    
    public String toString()
    {
        return this.type + " (" + this.maxPersons + "): " + this.persons +
        " persons \tfuel: " + this.fuel + "\n";
    }
    
    public int unload(int cargo)
    {
        int number;
        if (persons >= cargo) 
        {
            persons -= cargo;
            number = cargo;
        }
        else 
        {
            number = persons;
            persons = 0;
        }
        return number;
    }
    
    public int load(int cargo)
    {
        int number;
        if (persons + cargo <= maxPersons) 
        {
            persons += cargo;
            number = cargo;
        }
        else 
        {
            number = maxPersons - persons;
            persons = maxPersons;
        }
        return number;
    }
    
    public void refuel(int fuel)
    {
        this.fuel += fuel;
    }
    
    public void run(int distance)
    {
        if( distance * persons/2.0 <= fuel)
        {
          fuel -= (int)(distance * persons/2.0);
        }
    }
}
